<?php
/*
Plugin Name: Map on Post/Page
Plugin URI: http://wpexplored.com
Description: It allows you to add google maps along with a pin to show an address on your post or page in wordpress. Just either search or drag and drop the pin to the place . 
Version: 1.1
Author: Sunil Chaulagan
Author URI: http://wpexplored.com
License: GPLv2 or later
*/

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
/* Define the custom box */


add_action( 'add_meta_boxes', 'myplugin_add_custom_box' );

// backwards compatible (before WP 3.0)
// add_action( 'admin_init', 'myplugin_add_custom_box', 1 );

/* Do something with the data entered */
add_action( 'save_post', 'myplugin_save_postdata' );

/* Adds a box to the main column on the Post and Page edit screens */
function myplugin_add_custom_box() {
    add_meta_box( 
        'myplugin_sectionid',
        __( 'Add google Map with a pin', 'myplugin_textdomain' ),
        'myplugin_inner_custom_box',
        'post' 
    );
    add_meta_box(
        'myplugin_sectionid',
        __( 'Add Google Map with a pin ', 'myplugin_textdomain' ), 
        'myplugin_inner_custom_box',
        'page'
    );
}

/* Prints the box content */
function myplugin_inner_custom_box( $post ) {
wp_enqueue_script('jquery');
  // Use nonce for verification
  wp_nonce_field( plugin_basename( __FILE__ ), 'myplugin_noncename' );
$lat=get_post_meta(get_the_ID(),'mappost_latitude');
$long=get_post_meta(get_the_ID(),'mappost_longitude');
$zoomlevel=get_post_meta(get_the_ID(),'mappost_zoomlevel');
$maptype=get_post_meta(get_the_ID(),'mappost_maptype');
$activebox=get_post_meta(get_the_ID(),'mappost_activebox');
  ?>
  <style>
  #canvas {
    min-width: 400px;
    min-height: 400px;
}
</style>
<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
<script type="text/javascript" >
function open_win()
{
data=document.getElementById("searchtext");
window.location="<?php echo get_site_url(); ?>/wp-admin/post.php?post=<?php echo $post->ID; ?>&action=edit&searchtext="+data.value;

}

</script>
<label for="latitude">Add Map</label>
<?php if(isset($_POST['activebox'])) { ?>
	<input name="activebox" id="activebox" type="checkbox" checked="checked" />

<?php } else { ?>
 <?php if(isset($activebox['0']) && $activebox['0']==1 ) { ?>
 <input name="activebox" id="activebox" type="checkbox" checked="checked"  />
 <?php } else { ?>
 <input name="activebox" id="activebox" type="checkbox"  />
 <?php } ?>
<?php } ?>
<form action="" method="get" name="searchform">
<input type="text" id="searchtext" name="searchtext" value="<?php if(isset($_GET['searchtext'])) { echo $_GET['searchtext']; } ?>"  maxlength="100"  />
<input type="button" class="button" value="Find address"  onclick="open_win()" /> [If you are about to search , then save the above changes first.]
								</form>

<hr /><br />

	
<?php
            $sPattern = ' ';
            $sReplace = '+';
            $searchtext=str_replace( $sPattern, $sReplace, $_GET['searchtext'] );
            $geocode=file_get_contents('http://maps.google.com/maps/api/geocode/json?address='.$searchtext.'&sensor=false');
            $output= json_decode($geocode);
            if($output->status=='OK') {
                $lati = $output->results[0]->geometry->location->lat;
                $longi = $output->results[0]->geometry->location->lng;
               
                }
                ?>
                
  <div id="canvas"></div>
	
	<?php if(isset($lati) && isset($longi)) { ?>
	<input name="latitude" id="latitude" type="hidden" value="<?php echo $lati; ?>" />
	<input name="longitude" id="longitude" type="hidden" value="<?php echo $longi; ?>" />
	<input name="zoomlevel" id="zoomlevel" type="hidden" value="<?php echo $zoomlevel['0']; ?>" />
	<input name="maptype" id="maptype" type="hidden" value="<?php echo $maptype['0']; ?>" />
	<?php } else { ?>
        <input name="latitude" id="latitude" type="hidden" value="<?php echo $lat['0']; ?>" />
	<input name="longitude" id="longitude" type="hidden" value="<?php echo $long['0']; ?>" />
	<input name="zoomlevel" id="zoomlevel" type="hidden" value="<?php echo $zoomlevel['0']; ?>" />
	<input name="maptype" id="maptype" type="hidden" value="<?php echo $maptype['0']; ?>" />
	
        <?php } ?>
	
	
		<script type="text/javascript" >
var myZoom = <?php if(isset($zoomlevel['0'])){ echo $zoomlevel['0']; } else { echo '12';}?>;
var myType = <?php if(isset($maptype['0'])){ echo '\''.$maptype['0'].'\''; } else { echo '\'roadmap\'';}?>;
var myMarkerIsDraggable = true;
var myCoordsLenght = 6;
<?php if(isset($lati)&&isset($longi)) { ?>
var defaultLat = <?php echo $lati; ?>;
var defaultLng = <?php echo $longi; ?>;
<?php } else { ?>
var defaultLat = <?php if(isset($lat['0'])&& $lat['0']!='') { echo $lat['0']; } else { echo '37.973787'; }?> ;
var defaultLng = <?php if(isset($long['0'])&& $long['0']!='') { echo $long['0']; } else { echo '23.722426'; }?>;
<?php } ?>
// creates the map
// zooms
// centers the map
// sets the map's type 
var map = new google.maps.Map(document.getElementById('canvas'), {
	zoom: myZoom,
	center: new google.maps.LatLng(defaultLat, defaultLng),
	mapTypeId: myType 
});

// creates a draggable marker to the given coords
var myMarker = new google.maps.Marker({
	position: new google.maps.LatLng(defaultLat, defaultLng),
	draggable: myMarkerIsDraggable
});

// adds a listener to the marker
// gets the coords when drag event ends
// then updates the input with the new coords
google.maps.event.addListener(myMarker, 'dragend', function(evt){
	document.getElementById('latitude').value = evt.latLng.lat().toFixed(myCoordsLenght);
	document.getElementById('longitude').value = evt.latLng.lng().toFixed(myCoordsLenght);
	document.getElementById('zoomlevel').value = map.getZoom();
	document.getElementById('maptype').value = map.getMapTypeId();
});

// centers the map on markers coords
map.setCenter(myMarker.position);
document.getElementById('zoomlevel').value = map.getZoom();
	document.getElementById('maptype').value = map.getMapTypeId();
// adds the marker on the map
myMarker.setMap(map);
</script>


<?php

}

/* When the post is saved, saves our custom data */
function myplugin_save_postdata( $post_id ) {
  // verify if this is an auto save routine. 
  // If it is our form has not been submitted, so we dont want to do anything
  if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
      return;

  // verify this came from the our screen and with proper authorization,
  // because save_post can be triggered at other times

  if ( !wp_verify_nonce( $_POST['myplugin_noncename'], plugin_basename( __FILE__ ) ) )
      return;

  
  // Check permissions
  if ( 'page' == $_POST['post_type'] ) 
  {
    if ( !current_user_can( 'edit_page', $post_id ) )
        return;
  }
  else
  {
    if ( !current_user_can( 'edit_post', $post_id ) )
        return;
  }

  // OK, we're authenticated: we need to find and save the data

  //if saving in a custom table, get post_ID
  $post_ID = $_POST['post_ID'];
  $mylatitude = $_POST['latitude'];
  $mylongitude = $_POST['longitude'];
  $myzoom = $_POST['zoomlevel'];
  $mytype = $_POST['maptype'];
if(count(get_post_meta(get_the_ID(),'latitude'))<1) 
add_post_meta($post_ID,'mappost_latitude',$mylatitude);
else 
update_post_meta($post_ID,'mappost_latitude',$mylatitude);

if(count(get_post_meta(get_the_ID(),'longitude'))<1) 
add_post_meta($post_ID,'mappost_longitude',$mylongitude);
else
update_post_meta($post_ID,'mappost_longitude',$mylongitude);

if(count(get_post_meta(get_the_ID(),'zoomlevel'))<1) 
add_post_meta($post_ID,'mappost_zoomlevel',$myzoom);
else
update_post_meta($post_ID,'mappost_zoomlevel',$myzoom);

if(count(get_post_meta(get_the_ID(),'maptype'))<1) 
add_post_meta($post_ID,'mappost_maptype',$mytype);
else
update_post_meta($post_ID,'mappost_maptype',$mytype);

if(isset($_POST['activebox'])){
	if(count(get_post_meta(get_the_ID(),'mappost_activebox'))<1) { 
		add_post_meta($post_ID,'mappost_activebox','1');
		 } else {
		update_post_meta($post_ID,'mappost_activebox','1');
		}

} else {

	if(count(get_post_meta(get_the_ID(),'mappost_activebox'))<1) { 
	add_post_meta($post_ID,'mappost_activebox','0');
	 } else {
	update_post_meta($post_ID,'mappost_activebox','0');
	}
}

 
}

function my_metabox_callback ( $content ) {
wp_enqueue_script('jquery');
     echo $content;
     $lat=get_post_meta(get_the_ID(),'mappost_latitude'); // outputs value of custom field
$long=get_post_meta(get_the_ID(),'mappost_longitude');
$activebox=get_post_meta(get_the_ID(),'mappost_activebox');
$zoomlevel=get_post_meta(get_the_ID(),'mappost_zoomlevel');
$maptype=get_post_meta(get_the_ID(),'mappost_maptype');
$randid=rand();
if($activebox['0']==1){
?>

 
 
<script type="text/javascript" src="http://www.google.com/jsapi"></script>

<script type="text/javascript">
    
    google.load("maps", 3, {other_params:"sensor=false"});
    google.setOnLoadCallback(function() {
            var options = {
                  zoom: <?php echo $zoomlevel['0']; ?>,
                   center: new google.maps.LatLng(<?php echo $lat['0']; ?>,<?php echo $long['0']; ?>),
          mapTypeId: <?php echo '\''.$maptype['0'].'\''; ?>
            }
            map = new google.maps.Map(document.getElementById('map_canvas<?php echo $randid; ?>'), options);
 var myLatLng = new google.maps.LatLng(<?php echo $lat['0']; ?>,<?php echo $long['0']; ?>);
        var beachMarker = new google.maps.Marker({
            position: myLatLng,
            map: map
        });


    });



</script>
   
    <div id="map_canvas<?php echo $randid; ?>" style=" width: 500px;height: 300px;background:#ddd;"></div>
    <br />
<?php
}
}

//add_filter('the_content', 'add_post_content');
add_filter('the_content', 'my_metabox_callback');

 ?>